#!/bin/sh
#
#
##############################
# variables assigned by macros
##############################
. theActorPath/WVL_Experiment_Name`_'WVL_Actor_ID`_lib.sh'
logfile=theActorPath/WVL_Experiment_Name`_'WVL_Actor_ID.log
timescript=theActorPath/time
binpath=WVL_SYS_Echo(`WVL_Host_'theHost`_BinPath')
dbpath=WVL_SYS_Echo(`WVL_Component_'theComponent`_DBPath')
changequote([[, ]])dnl

#########################################################
# parse parameter
#########################################################
#
# parse parameters
# $command is what to do with the object [add | del | replace | change | show]
#
command=`echo $parameter|awk -F[,] '{print $1}'`
destIP=`echo $parameter|awk -F[,] '{print $2}'`
commandParams=`echo $parameter|awk -F[,] '{print $3}'`
interface=`ip route get $destIP | grep -o "dev .*" | cut -d\  -f 2`

######################################################
# workload interpretation
# (weevil-defined variables: $event, $parameter, $timestampscript, $actorpath, $comppath, $softwarepath)
######################################################
# $event is the type of traffic control object to use [qdisc | filter | class] (see tc man pages)
if [ $command == "show" ];
then
    flag="-s"
fi
# call timestampscript to log the qdisc event with the trial-time
sh $timestampscript $logfile "sudo tc $flag $event $command dev $interface $commandParams"
echo -e "\n" >> $logfile
# run tc    
date +"%F %T:%N %z" >> $logfile 2>&1 &
sudo tc $flag $event $command dev $interface $commandParams >> $logfile 2>&1 &
changequote(`, ')dnl
