# -*- Makefile -*-
#
#  This file is part of WEEVIL.
#
#  Authors: See the file AUTHORS for full details.
#
#  Copyright (C) 2002-2006 University of Colorado
#
#  Weevil is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  Weevil is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301
#  USA, or send email to serl@cs.colorado.edu.
#
# $Id: weevilgen2makefile.m4.in,v 1.2 2004/11/10 20:52:16 ywang Exp $
#
# !!! this Makefile is automatically generated by WEEVILGEN, do not change manually !!!
prefix=/usr
PACKAGE=weevil
VERSION=1.2.0
libdir=$(prefix)/lib
includedir=$(prefix)/include
ssim_prefix=
FALSE=/bin/false
GM4=/usr/bin/m4
ECHO=/bin/echo
RM=/bin/rm
SH=/bin/sh
GREP=/bin/grep
TOUCH=/usr/bin/touch
EXPR=/usr/bin/expr




WKLD_NAME = wkld_sequential

weevilgen_LIBDIR = $(libdir)/$(PACKAGE)-$(VERSION)
weevilgen_CXXFLAGS = $(CXXFLAGS) $(SIM_CXXFLAGS) -I$(includedir) -I$(ssim_prefix)/include
weevilgen_LDLIBS = $(LDLIBS) $(SIM_LDLIBS) -L$(libdir) -L$(ssim_prefix)/lib -lweevil -lssim
weevilgen_ENV = LD_LIBRARY_PATH=$(SIM_LD_LIBRARY_PATH)$(ssim_prefix)/lib:$(libdir):$(LD_LIBRARY_PATH) && \
	export LD_LIBRARY_PATH &&
weevilgen_FROZEN = $(WKLD_NAME).m4f

all:
	@$(ECHO) "weevilgen: ERROR: no default target"

.PHONY: all check clean gen

check: $(WKLD_NAME).chk

clean:
	$(RM) -f $(WKLD_NAME).wkld $(WKLD_NAME).sim $(WKLD_NAME).cc \
	$(WKLD_NAME).chk $(WKLD_NAME).m4f

gen: check $(WKLD_NAME).wkld
	@$(ECHO) "weevilgen: successfully generate workload: $(WKLD_NAME)"

$(WKLD_NAME).m4f: $(weevilgen_LIBDIR)/weevilgen-defs.m4 $(WKLD_NAME).m4
	@$(GM4) -F $@ $+

$(WKLD_NAME).chk: $(WKLD_NAME).m4f $(weevilgen_LIBDIR)/weevilgen-checks.m4
	@if $(GM4) -R $< $(weevilgen_LIBDIR)/weevilgen-checks.m4; then $(TOUCH) $@; else $(FALSE); fi

$(WKLD_NAME).wkld : $(WKLD_NAME).sim
	@$(ECHO) -n "weevilgen: creating unified workload: $@..."
	$(weevilgen_ENV) ./$< > $@
	@$(ECHO) "done"

$(WKLD_NAME).sim : $(WKLD_NAME).cc
	@$(ECHO) -n "weevilgen: compiling workload simulation: $@..."
	$(CXX) $(weevilgen_CXXFLAGS) $(SIM_CXXFLAGS) $< -o $@ $(weevilgen_LDLIBS) $(SIM_LDLIBS)
	@$(ECHO) "done"

$(WKLD_NAME).cc : $(WKLD_NAME).m4f $(weevilgen_LIBDIR)/weevilgen2wkldsim.m4
	@$(ECHO) -n "weevilgen: generating workload simulation source file: $@..."
	@$(GM4) -R $+ > $@
	@$(ECHO) "done"
